#include "stdio.h"
#include <rpc/rpc.h>
#include <rpcsvc/rstat.h>
#include <netdb.h>

struct statstime hstat;

main(int argc, char **argv) {
  char *thishost;
  /* the following 3 lines are for the netgroup support */
  char c;
  int x;
  char *mp, *up, *dp;
  float load_crit, load_max, load_host, scale;
  if (argc == 1) {
    printf("No hosts specified\n");
    exit(1);
  }
  load_crit = 0.0;
  load_max = 1000000.0;
  scale = (float)(1<<FSHIFT);
  while (thishost = *++argv) {
    if ( !strcmp(thishost,"-g") ) {
      thishost = *++argv;
      sscanf(thishost,"%f",&load_crit);
    } else if ( !strcmp(thishost,"-l") ) {
      thishost = *++argv;
      sscanf(thishost,"%f",&load_max);
    } else if (thishost[0] == '@') {
      x=1;
      c = thishost[x];
      while (c != '\0') {
	thishost[x-1] = thishost[x];
	x++;
	c = thishost[x];
      }
      thishost[x-1] = '\0';
      if (!setnetgrent(thishost)) {
	while (getnetgrent(&mp,&up,&dp)) {
	  if (rstat(mp, &hstat) == RPC_SUCCESS) {
	    load_host = (float)(hstat.avenrun[0])/scale;
	    if ((load_host >= load_crit) && (load_host <= load_max)) {
	      printf("%s : %.2f\n",mp,load_host);
	    }
	  }
	}
      }
    } else {
      if (rstat(thishost, &hstat) == RPC_SUCCESS) {
	load_host = (float)(hstat.avenrun[0])/scale;
	if ((load_host >= load_crit) && (load_host <= load_max)) {
	  printf("%s : %.2f\n",thishost,load_host);
	}
      }
    }
  }
}
